﻿// Builder Workshop

#include "Requirements.as"
#include "ShopCommon.as";
#include "Descriptions.as";
#include "WARCosts.as";
#include "CheckSpam.as";

void onInit( CBlob@ this )
{	 
	this.set_TileType("background tile", CMap::tile_wood_back);
	//this.getSprite().getConsts().accurateLighting = true;
	

	this.getSprite().SetZ(-50); //background
	this.getShape().getConsts().mapCollisions = false;

	// SHOP

	this.set_Vec2f("shop offset", Vec2f(0, 0));
	this.set_Vec2f("shop menu size", Vec2f(4,4));	
	this.set_string("shop description", "Buy");
	this.set_u8("shop icon", 25);

	{	 
		ShopItem@ s = addShopItem( this, "Lantern", "$lantern$", "lantern", descriptions[9], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_LANTERN );
	}
	{
		ShopItem@ s = addShopItem( this, "Bucket", "$bucket$", "bucket", descriptions[36], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_BUCKET );
	}
	{
		ShopItem@ s = addShopItem( this, "Sponge", "$sponge$", "sponge", descriptions[53], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_SPONGE );
	}
	
	{
		ShopItem@ s = addShopItem( this, "Boulder", "$boulder$", "boulder", descriptions[17], false );
		AddRequirement( s.requirements, "blob", "mat_stone", "Stone", 35 );
	}
	
	{
		ShopItem@ s = addShopItem( this, "Trampoline", "$trampoline$", "trampoline", descriptions[30], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_TRAMPOLINE );
	}
	
	{	 
		ShopItem@ s = addShopItem( this, "Saw", "$saw$", "saw", descriptions[12], false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", COST_WOOD_SAW );
		AddRequirement( s.requirements, "blob", "mat_stone", "Stone", 100 );
	}
	{	 
		ShopItem@ s = addShopItem( this, "Drill", "$drill$", "drill", descriptions[43], false );
		AddRequirement( s.requirements, "blob", "mat_stone", "Stone", COST_STONE_DRILL );
	}
	{	 
		ShopItem@ s = addShopItem( this, "Sack", "$Sack$", "sack", "Sack for gold", false );
		AddRequirement( s.requirements, "blob", "mat_wood", "Wood", 100 );
	}
	this.set_string("required class", "builder");
}

void GetButtonsFor( CBlob@ this, CBlob@ caller )
{
	this.set_bool("shop available", this.isOverlapping(caller) /*&& caller.getName() == "builder"*/ );
}
								   
void onCommand( CBlob@ this, u8 cmd, CBitStream @params )
{
	if (cmd == this.getCommandID("shop made item"))
	{
		this.getSprite().PlaySound( "/ChaChing.ogg" );
	}
}
